unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

  procedure MirrorImage(FromImage, ToImage : TImage);
  procedure VerticalText(C: TCanvas; X,Y: Integer; S: String; TextColor: TColor);
var
  Form1: TForm1; 

implementation

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
   i,j,w,h : Integer;
begin
  w := Image1.Canvas.TextWidth('Test');
  h := Image1.Canvas.TextHeight('Test');

  //Image1.Width:=w;
  //Image1.Height:=h;
  
  //Image2.Width:=h;
  //Image2.Height:=w;
  
  //VerticalText(Image1.Canvas,0,0,'Text',clWhite, clFuchsia);
  VerticalText(Image1.Canvas,2,2,'Mehr Text',clWhite);
  
  {Image1.Canvas.TextOut(0,0,'Test');

  MirrorImage(Image1, Image2);
  
  for i := 0 to Image1.Width do
    for j := 0 to Image1.Height do
     Image1.Canvas.Pixels[j,i]:=Image2.Canvas.Pixels[i,j];
     
  for i := 0 to Image1.Width do
    for j := 0 to Image1.Height do
     Image2.Canvas.Pixels[Image2.Width-i,Image2.Height-j]:=Image1.Canvas.Pixels[i,j];

  //MirrorImage(Image1, Image2);}
end;

procedure MirrorImage(FromImage, ToImage : TImage);
var
   i, j : Integer;
begin
   for i := 0 to FromImage.Width do
    for j := 0 to FromImage.Height do
        {
          Y: ToImage.Height-j = um 180°
          Y: j = spiegel
        }
     ToImage.Canvas.Pixels[ToImage.Width-i,j]:=FromImage.Canvas.Pixels[i,j];
end;

procedure VerticalText(C: TCanvas; X,Y: Integer; S: String; TextColor: TColor);
const
   Background : TColor = clFuchsia;
var
   t1, t2 : TBitmap;
   i,j,w,h,q: Integer;
begin

   t1 := TBitmap.Create;
   t2 := TBitmap.Create;
   
   w := C.TextWidth(S);
   h := C.TextHeight(S);

   q := w;
   
   t1.Height:=q;
   t1.Width:=q;
   
   t2.Height:=q;
   t2.Width:=q;
   
   with t1.Canvas do
   begin

     Font := C.Font;
     Font.Color:=TextColor;
     
     Brush.Color:=Background;
     FillRect(0,0,q,q);
     Brush.Style:=bsClear;
     TextOut(0,0,S);
     Brush.Style:=bsSolid;
   end;
   
   t1.TransparentColor:=Background;
   t1.Transparent:=true;
   
   t2.TransparentColor:=Background;
   t2.Transparent:=true;
   
   with t2.Canvas do
   begin
     Font.Color:=C.Font.Color;
     Font := C.Font;

     Brush.Color:=Background;
     FillRect(0,0,q,q);
   end;
   
   //Spiegeln
   for i := 0 to T1.Width do
    for j := 0 to T1.Height do
        {
          Y: ToImage.Height-j = um 180°
          Y: j = spiegel
        }
      T2.Canvas.Pixels[T2.Width-i,j]:=T1.Canvas.Pixels[i,j];
   
   //vergessen ^^
   for i := 0 to T1.Width do
    for j := 0 to T1.Height do
     T1.Canvas.Pixels[j,i]:=T2.Canvas.Pixels[i,j];

   //um 180°C drehen
   for i := 0 to T1.Width do
    for j := 0 to T1.Height do
     T2.Canvas.Pixels[T2.Width-i,T2.Height-j]:=T1.Canvas.Pixels[i,j];
   
   //C.Draw(X+4-h,Y-1, T2);
   
   //Text auf C transparent ausgeben
   for i := 0 to T1.Width do
    for j := 0 to T1.Height do
      if T2.Canvas.Pixels[i,j] <> Background then
         C.Pixels[i+X-(q-h)-1,j+Y] := T2.Canvas.Pixels[i,j];

   t1.Free;
   t2.Free;
end;

initialization
  {$I unit1.lrs}

end.

